<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_helloworld
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * HobOsm Controller
 *
 * @package     Joomla.Administrator
 * @subpackage  com_hobosm
 * @since       1.0.0
 */
class HobOsmControllerLicense extends JControllerForm
{


	/*
	* POST http://licences.hob-fr.com/api/auth
	* Get the token for identification on the page licences.hob-fr.com
	*/
	private function auth_licence($licenseKey, $licenseEmail)
{
	//POST the email and the password to get Authorization

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$params = array(
		"email" => $licenseEmail,
		"password" => $licenseKey,
		"expiresIn" => 24,
	);
	curl_setopt($ch, CURLOPT_URL, "http://licences.123-domaine.com/api/auth");
	curl_setopt($ch, CURLOPT_HTTPHEADER, array('x-hob-apikey: p_key_5d496e4c75b4b9.55276418','User-Agent: '.$_SERVER['HTTP_USER_AGENT']));
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));

	$result = json_decode(curl_exec($ch));
	//If return success
	if ($result->success) {
		return $result->token;

	} else {
		return false;
	}
}

	/*
	 * Subscribe
	 * POST http://licences.hob-fr.com/api/subscribe
	 *
	 * firstname	required
	 * lastname	    required
	 * email	    required
	 * companyName	required for the bill
	 * address	    required
	 *
	 * If the subscription is "successful" -> save the userToken in the Database.
	 * To get the identification token for licences.hob-fr.com site, we call the previous function ("auth licence")
	 * If everything if fine redirect the user to the buying page
	 * */

	public function subscribe_licence()
	{
		$app      = JFactory::getApplication();
		$document = JFactory::getDocument();
		$form     = $app->input->get('jform', '', 'RAW');
		$ch       = curl_init();
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$params = array(
			"firstname"   => $form['firstname'],
			"lastname"    => $form['lastname'],
			"email"       => $form['email'],
			"companyName" => $form['company'],
			"address"     => $form['address']
		);
		if($form['registed_mail']&&$form['registed_token']&&intval($form['new_license']) === 0){

			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__hobosm_license_active'));
			$db->setQuery($query);
			$db->execute();


			$license = new stdClass();
			$license->email = $form['registed_mail'];
			$license->token=$form['registed_token'];

			JFactory::getDbo()->insertObject('#__hobosm_license_active', $license);
		}
		if (intval($form['new_license']) === 1)
		{
			curl_setopt($ch, CURLOPT_URL, "http://licences.123-domaine.com/api/subscribe");
			curl_setopt($ch, CURLOPT_HTTPHEADER, array('x-hob-apikey: p_key_5d496e4c75b4b9.55276418', 'User-Agent: ' . $_SERVER['HTTP_USER_AGENT']));
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
			$result = json_decode(curl_exec($ch));

			if ($result->success)
			{

				$userToken = $result->userToken;
				$authToken = self::auth_licence($userToken, $form['email']);
				$url       = 'http://licences.123-domaine.com/2/product/10?token=' . $authToken;
				// Obtain a database connection
				$db = JFactory::getDbo();
				// Retrieve the shout
				$query = $db->getQuery(true)
					->select($db->quoteName('email'))
					->from($db->quoteName('#__hobosm_license'))
					->where('email = ' . $db->Quote($form['email']));
				// Prepare the query
				$db->setQuery($query);
				// Load the row.
				$result = $db->loadResult();


				if ($result === $form['email'])
				{
					//UPDATE
					$db    = JFactory::getDbo();
					$query = $db->getQuery(true);
					// Fields to update.
					$fields = array(
						$db->quoteName('token') . ' = ' . $db->quote($userToken)
					);
					// Conditions for which records should be updated.
					$conditions = array(
						$db->quoteName('email') . ' = ' . $db->quote($form['email'])
					);
					$query->update($db->quoteName('#__hobosm_license'))->set($fields)->where($conditions);
					$db->setQuery($query);
					$db->execute();

					$app->redirect($url);
				}
				else
				{
					//INSERT
					// Get a db connection.
					$db = JFactory::getDbo();
					// Create a new query object.
					$query = $db->getQuery(true);
					// Insert columns.
					$columns = array('email', 'token');
					// Insert values.
					$values = array('"' . $form['email'] . '"', '"' . $userToken . '"');
					// Prepare the insert query.
					$query
						->insert($db->quoteName('#__hobosm_license'))
						->columns($db->quoteName($columns))
						->values(implode(',', $values));
					// Set the query using our newly populated query object and execute it.
					$db->setQuery($query);
					$db->execute();

					$app->redirect($url);
				}
			}
			else
			{
				$document->addScriptDeclaration('
                
                    alert("Server reply not success");
                
            ');

				return false;

			}

			return false;
		}
		$currentUri = (string)JUri::getInstance();
		//$this->setMessage(JText::_('COM_HOBOSM_NOT_NEW_LICENSE'), 'warning');
		$this->setRedirect(
			$currentUri
		);

		return true;
	}

	/*
	 * POST http://licences.hob-fr.com/api/auth
	 * Identification
	 * Verify the license and the expiration date.
	 *
	 * To the verification we need the email address and the userToken.
	 * E-mail and Password -> GET from getLicenseKey function
	 *
	 * */




	/**
     * Implement to allowAdd or not
     *
     * Not used at this time (but you can look at how other components use it....)
     * Overwrites: JControllerForm::allowAdd
     *
     * @param array $data
     * @return bool
     */
    protected function allowAdd($data = array())
    {
        return parent::allowAdd($data);
    }
    /**
     * Implement to allow edit or not
     * Overwrites: JControllerForm::allowEdit
     *
     * @param array $data
     * @param string $key
     * @return bool
     */
    protected function allowEdit($data = array(), $key = 'id')
    {
        $id = isset( $data[ $key ] ) ? $data[ $key ] : 0;
        if( !empty( $id ) )
        {
            return JFactory::getUser()->authorise( "core.edit", "com_hobosm.hobosm." . $id );
        }
    }
}