<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_hobosm
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * HelloWorld component helper.
 *
 * @param   string  $submenu  The name of the active view.
 *
 * @return  void
 *
 * @since   1.6
 */
abstract class HobOsmHelper extends JHelperContent
{
    /**
     * Configure the Linkbar.
     *
     * @return Bool
     */

    public static function addSubmenu($submenu)
    {
        JHtmlSidebar::addEntry(
            JText::_('COM_HOBOSM_SUBMENU_DASHBOARD'),
            'index.php?option=com_hobosm',
            $submenu == 'dashboard'
        );

        JHtmlSidebar::addEntry(
            JText::_('COM_HOBOSM_SUBMENU_MESSAGES'),
            'index.php?option=com_hobosm&view=hobosms',
            $submenu == 'hobosms'
        );

        JHtmlSidebar::addEntry(
            JText::_('COM_HOBOSM_SUBMENU_CATEGORIES'),
            'index.php?option=com_categories&view=categories&extension=com_hobosm',
            $submenu == 'categories'
        );
	    JHtmlSidebar::addEntry(
		    JText::_('COM_HOBOSM_SUBMENU_LICENSE'),
		    'index.php?option=com_hobosm&view=license',
		    $submenu == 'license'
	    );

        // Set some global property
        $document = JFactory::getDocument();
        $document->addStyleDeclaration('.icon-48-hobosm ' .
            '{background-image: url(../media/com_hobosm/images/tux-48x48.png);}');
        if ($submenu == 'categories')
        {
            $document->setTitle(JText::_('COM_HOBOSM_ADMINISTRATION_CATEGORIES'));
        }
    }

	public static function infos_licence($licenseKey, $licenseEmail)
	{
		//POST the email and the password to get Authorization

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$params = array(
			"email" => $licenseEmail,
			"password" => $licenseKey,
		);
		curl_setopt($ch, CURLOPT_URL, "http://licences.123-domaine.com/api/auth");
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('x-hob-apikey: p_key_5d496e4c75b4b9.55276418',
			'User-Agent: '.$_SERVER['HTTP_USER_AGENT']));
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));

		$result = json_decode(curl_exec($ch));
//If return success
		if(is_object($result)) {
			if ($result->success) {
				if ($result->hasActiveLicense) {
					//Check the license, if NOT trial
					if ($result->otherLicence[0]->license != 'trial') {
						$license_expire = $result->otherLicence[0]->end;
						$time = strtotime(str_replace('/', '-', $license_expire));
						$day1 = date_create(date('Y-m-d', $time));
						$day2 = date_create(date("Y-m-d", strtotime("now")));
						$day_left = date_diff($day2, $day1);
						return $license_expire;
					} elseif ($result->willExpire[0]->license != 'trial') {
						$license_expire = $result->willExpire[0]->end;
						$time = strtotime(str_replace('/', '-', $license_expire));
						$day1 = date_create(date('Y-m-d', $time));
						$day2 = date_create(date("Y-m-d", strtotime("now")));
						$day_left = date_diff($day2, $day1);
						return $license_expire;
					} else {
						return false;
					}
				} else {
					return false;
				}
			} else {
				return false;
			}
		}else {
			return false;
		}
	}
}