<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_helloworld
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

JFormHelper::loadFieldClass('list');

/**
 * HobOSM Form Field class for the HobOSM component
 *
 * @since  0.0.1
 */
class JFormFieldHobOsm extends JFormFieldList
{
    /**
     * The field type.
     *
     * @var         string
     */
    protected $type = 'HobOsm';

    /**
     * Method to get a list of options for a list input.
     *
     * @return  array  An array of JHtml options.
     */
    protected function getOptions()
    {
        $db    = JFactory::getDBO();
        $query = $db->getQuery(true);
        $query->select('#__hobosm.id as id,#__hobosm.name as name,#__categories.title as category,catid');
        $query->from('#__hobosm');
        $query->leftJoin('#__categories on catid=#__categories.id');
        // Retrieve only published items
        $query->where('#__hobosm.published = 1');
        $db->setQuery((string) $query);
        $places = $db->loadObjectList();
        $options  = array();

        if ($places)
        {
            foreach ($places as $place)
            {
                $options[] = JHtml::_('select.option', $place->id, $place->name.
                    ($place->catid ? ' (' . $place->category . ')' : ''));
            }
        }

        $options = array_merge(parent::getOptions(), $options);

        return $options;
    }





}