<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_HOBOSM
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

use Joomla\Registry\Registry;

/**
 * hobosms View
 *
 * @since  0.0.1
 */
class HobOsmViewDashboard extends JViewLegacy
{
    /**
     * Display the Hello World view
     *
     * @param   string  $tpl  The name of the template file to parse; automatically searches through the template paths.
     *
     * @return  void
     **/
    function display($tpl = null)
    {
        // Get data from the model
        $this->items		= $this->get('Items');
        $this->pagination	= $this->get('Pagination');
	    $this->model = $this->getModel();

        // Check for errors.
        if (count($errors = $this->get('Errors')))
        {
            JError::raiseError(500, implode('<br />', $errors));

            return false;
        }

        // Set the submenu
        HobOsmHelper::addSubmenu('dashboard');

        // Set the toolbar and number of found items
        $this->addToolBar();

	    // Display the template
	    parent::display($tpl);

        // Set the document
        $this->setDocument();
    }

    /**
     * Add the page title and toolbar.
     *
     * @return  void
     *
     * @since   1.6
     */
    protected function addToolBar()
    {
        $title = JText::_('COM_HOBOSM_MANAGER_HOBOSMS');

        JToolBarHelper::title($title, 'hobosm');

    }
    /**
     * Method to set up the document properties
     *
     * @return void
     */
    protected function setDocument()
    {
        $document = JFactory::getDocument();
        $document->setTitle(JText::_('COM_HOBOSM_ADMINISTRATION'));
    }
}