<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_HOBOSM
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

use Joomla\Registry\Registry;

/**
 * hobosms View
 *
 * @since  0.0.1
 */
class HobOsmViewHobOsms extends JViewLegacy
{
    /**
     * Display the Hello World view
     *
     * @param   string  $tpl  The name of the template file to parse; automatically searches through the template paths.
     *
     * @return  void
     */
    function display($tpl = null)
    {

        // Get application
        $app = JFactory::getApplication();
        $context = "hobosm.list.admin.hobosm";
        // Get data from the model
        $this->items		= $this->get('Items');
        $this->pagination	= $this->get('Pagination');
        $this->state		= $this->get('State');

        $this->filterForm    	= $this->get('FilterForm');
        $this->activeFilters 	= $this->get('ActiveFilters');

        // What Access Permissions does this user have? What can (s)he do?
        $this->canDo = JHelperContent::getActions('com_hobosm');

        // Check for errors.
        if (count($errors = $this->get('Errors')))
        {
            throw new Exception(implode("\n", $errors), 500);
        }

        // Set the submenu
        HobOsmHelper::addSubmenu('hobosms');

        // Set the toolbar and number of found items
        $this->addToolBar();

        // Display the template
        parent::display($tpl);

        // Set the document
        $this->setDocument();
    }

    /**
     * Add the page title and toolbar.
     *
     * @return  void
     *
     * @since   1.6
     */
    protected function addToolBar()
    {
        $title = JText::_('COM_HOBOSM_MANAGER_HOBOSMS');


        JToolBarHelper::title($title, 'hobosm');

        if ($this->canDo->get('core.create'))
        {
            JToolBarHelper::addNew('hobosm.add', 'JTOOLBAR_NEW');
        }
        if ($this->canDo->get('core.edit'))
        {
            JToolBarHelper::editList('hobosm.edit', 'JTOOLBAR_EDIT');
        }
        if ($this->canDo->get('core.delete'))
        {
            JToolBarHelper::deleteList('', 'hobosms.delete', 'JTOOLBAR_DELETE');
        }
        JToolBarHelper::publish('hobosms.publish');
        JToolBarHelper::unpublish('hobosms.unpublish');
        if ($this->canDo->get('core.admin'))
        {
            JToolBarHelper::divider();
            JToolBarHelper::preferences('com_hobosm');
        }
    }
    /**
     * Method to set up the document properties
     *
     * @return void
     */
    protected function setDocument()
    {
        $document = JFactory::getDocument();
        $document->setTitle(JText::_('COM_HOBOSM_ADMINISTRATION'));
    }
}