<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_hobosm
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access
defined('_JEXEC') or die('Restricted access');
JHtml::_('behavior.formvalidator');
JHtml::_('formbehavior.chosen', 'select');
$license_id = $this->model->getLicense();
$license_expire = HobOsmHelper::infos_licence($license_id->token,$license_id->email);
//var_dump($license_id);
$time = strtotime(str_replace('/', '-', $license_expire));
$now = strtotime("now");



?>

<form action="<?php echo JRoute::_('index.php?option=com_hobosm&view=license&id=' . (int) $this->item->id); ?>"
      method="post" name="adminForm" id="adminForm" class="form-validate">

    <div  id="j-sidebar-container" class="span2 custom-sidebar">
		<?php echo JHtmlSidebar::render(); ?>
    </div>

    <div id="j-main-container" class="span10">
<div class="<?php echo $now <= $time ?  'alert alert-success':  'alert alert-error'; ?>">
    <h3><?php echo JText::_('COM_HOBOSM_LICENSE_INFO'); ?></h3>
    <table>
        <tr>
            <td><?php echo JText::_('COM_HOBOSM_LICENSE_EMAIL'); ?> : </td>
            <td><?php echo $license_id->email; ?></td>
        </tr>
        <tr>
            <td><?php echo JText::_('COM_HOBOSM_LICENSE_TOKEN'); ?> : </td>
            <td><?php echo $license_id->token; ?></td>
        </tr>
        <tr>
            <td><?php echo JText::_('COM_HOBOSM_LICENSE_END'); ?> : </td>
            <td><?php echo $license_expire; ?></td>
        </tr>
        <?php if ($now <= $time): ?>
        <tr>
            <td><?php echo JText::_('COM_HOBOSM_LICENSE_DAY_LEFT'); ?> : </td>
            <td><?php echo date('d',$time - $now); ?></td>
        </tr>
        <?php endif;?>
    </table>
</div>
        <div class="row-fluid">
            <fieldset class="adminform span4">
                <legend><?php echo JText::_('COM_HOBOSM_LICENSE_REGISTED_EMAIL') ?></legend>
                <div class="row-fluid">
                    <div class="span6">
				        <?php echo $this->form->renderFieldset('license');  ?>
                    </div>
                </div>
            </fieldset>

        <table class="table table-striped span8">
            <legend><?php echo JText::_('COM_HOBOSM_LICENSE_LIST') ?></legend>
            <tr>
                <th>E-mail</th>
                <th>Token</th>
            </tr>
		    <?php
		    foreach ($this->model->getAllLicense() as $license): ?>
            <?php if(HobOsmHelper::infos_licence($license->token,$license->email)): ?>
                <tr>
                    <td><?php  echo $license->email; ?></td>
                    <td><?php  echo $license->token; ?></td>
                </tr>
            <?php endif; ?>
		    <?php endforeach; ?>
        </table>

        </div>
        <fieldset class="adminform">
            <legend><?php echo JText::_('COM_HOBOSM_LICENSE_CREATE') ?></legend>
            <div class="row-fluid">
                <div class="span6">
                    <?php echo $this->form->renderFieldset('details');  ?>
                </div>
            </div>

        </fieldset>

    </div>
    <input type="hidden" name="task" value="license.edit" />
    <?php echo JHtml::_('form.token'); ?>
</form>



