<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_hobosm
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * HelloWorld View
 *
 * @since  0.0.1
 */
class HobOsmViewLicense extends JViewLegacy
{
    protected $form;
    protected $item;
    protected $script;
    protected $canDo;
    protected $model;

    /**
     * Display the Hello World view
     *
     * @param   string  $tpl  The name of the template file to parse; automatically searches through the template paths.
     *
     * @return  void
     */
    public function display($tpl = null)
    {
        // Get the Data
        $this->form = $this->get('Form');
        $this->item = $this->get('Item');
	    $this->model = $this->getModel();

        // What Access Permissions does this user have? What can (s)he do?
        $this->canDo = JHelperContent::getActions('com_hobosm', 'license', $this->item->id);

        // Check for errors.
        if (count($errors = $this->get('Errors')))
        {
            throw new Exception(implode("\n", $errors), 500);
        }

        // Set the toolbar
        $this->addToolBar();


	    // Set the submenu
	    HobOsmHelper::addSubmenu('license');

	    // Display the template
	    parent::display($tpl);
	    // Set the document
	    $this->setDocument();

    }

    /**
     * Add the page title and toolbar.
     *
     * @return  void
     *
     * @since   1.6
     */
    protected function addToolBar()
    {
        $isNew = ($this->item->id == 0);

        JToolBarHelper::title($isNew ? JText::_('COM_HOBOSM_MANAGER_LICENSE_NEW')
            : JText::_('COM_HOBOSM_MANAGER_LICENSE_ANOTHER'), 'hobosm');
        // Build the actions for new and existing records.
        if ($isNew)
        {
	        //Add custom link button to toolbar
	        $bar = & JToolBar::getInstance('toolbar');
	        $bar->appendButton( 'Link',  'back', JText::_('COM_HOBOSM_SUBMENU_DASHBOARD'), './index.php?option=com_hobosm&view=dashboard' );
            // For new records, check the create permission.
            if ($this->canDo->get('core.create'))
            {
                JToolBarHelper::apply('license.subscribe_licence', 'JTOOLBAR_APPLY');
                //JToolBarHelper::save('license.save', 'JTOOLBAR_SAVE');
            }


        }
        else
        {
            if ($this->canDo->get('core.edit'))
            {


            }


        }
    }
    /**
     * Method to set up the document properties
     *
     * @return void
     */
    protected function setDocument()
    {
        $isNew = ($this->item->id == 0);
        $document = JFactory::getDocument();
        $document->setTitle($isNew ? JText::_('COM_HOBOSM_HOBOSM_CREATING')
            : JText::_('COM_HOBOSM_HOBOSM_EDITING'));
    }

}
