jQuery(document).ready(function() {


    // We'll use OpenLayers to draw the map (http://openlayers.org/)
    var params = Joomla.getOptions('params');
    // Openlayers uses an x,y coordinate system for positions
    // We need to convert our lat/long into an x,y pair which is relative
    // to the map projection we're using, viz Spherical Mercator WGS 84
    var x=parseFloat(document.getElementById('jform_longitude').value);
    var y=parseFloat(document.getElementById('jform_latitude').value);



    if(x != 0){x=parseFloat(document.getElementById('jform_longitude').value);}
    else{x=parseFloat(params.longitude);}
    if(y != 0){y=parseFloat(document.getElementById('jform_latitude').value);}
    else{y = parseFloat(params.latitude);}

    var zoom_value = parseInt(document.getElementById("jform_zoom").value);
    if(zoom_value <= 0){zoom_value = params.zoom;}
    var mapCentre = ol.proj.fromLonLat([x, y]); // Spherical Mercator is assumed by default

    //The icon source, if we have use it, if not get the default
    var icon_source = document.getElementById('jform_imageinfo_image').value;
    if(!icon_source){icon_source = params.icon}
    else{icon_source ="../"+ document.getElementById('jform_imageinfo_image').value;}

    var icon_scale = parseFloat(document.getElementById('jform_scale').value);
        if(icon_scale <= 0){icon_scale = params.scale;}


    var infobox_content = document.getElementById('jform_greeting').value;
    var infobox_width = parseInt(document.getElementById('jform_width').value);
    var position_horizontal = parseInt(document.getElementById('jform_position_horizontal').value);
    if(position_horizontal = 0){position_horizontal = 1}
    var position_vertical = parseInt(document.getElementById('jform_position_vertical').value);

    console.log(params);
    console.log("Width: "+infobox_width +"  hori: "+position_horizontal + " verti: "+ position_vertical);
    /**
     * The position of the mouse
     */
    var mousePositionControl = new ol.control.MousePosition({
        coordinateFormat: ol.coordinate.createStringXY(7),
        projection: 'EPSG:4326',
        // comment the following two lines to have the mouse position
        // be placed within the map.
        className: 'custom-mouse-position',
        target: document.getElementById('mouse-position'),
        undefinedHTML: '&nbsp;'
    });


    /**
     * Elements that make up the popup.
     */
    var container = document.getElementById('popup');
    var content = document.getElementById('popup-content');
    var closer = document.getElementById('popup-closer');


    /**
     * Create an overlay to anchor the popup to the map.
     */
    var overlay = new ol.Overlay({
        element: container,
        autoPan: true,
        offset: [position_horizontal, position_vertical],
        autoPanAnimation: {
            duration: 250
        }
    });

    /**
     * Add a click handler to hide the popup.
     * @return {boolean} Don't follow the href.
     */
    closer.onclick = function () {
        overlay.setPosition(undefined);
        closer.blur();
        return false;
    };




    // To draw a map, Openlayers needs:
    // 1. a target HTML element into which the map is put
    // 2. a map layer, which can be eg a Vector layer with details of polygons for
    //    country boundaries, lines for roads, etc, or a Tile layer, with individual
    //    .png files for each map tile (256 by 256 pixel square).
    // 3. a view, specifying the 2D projection of the map (default Spherical Mercator),
    //    map centre coordinates and zoom level
    var map = new ol.Map({
        controls: ol.control.defaults({
            attributionOptions: {
                collapsible: false
            }
        }).extend([mousePositionControl]),
        target: 'map_osm',
        layers: [
            new ol.layer.Tile({  // we'll get the tiles from the OSM server
                source: new ol.source.OSM()
            })
        ],
        overlays: [overlay],
        view: new ol.View({  // default is Spherical Mercator projection
            center: mapCentre,
            zoom: zoom_value
        })
    });



    // Now we add a marker for our HobOsm position
    // To do that, we specify it as a Point Feature, and we add styling
    // to define how that Feature is presented on the map
    var hobosmPoint = new ol.Feature({geometry: new ol.geom.Point(mapCentre)});
    // we'll define the style as a red 5 point star with blue edging
    var iconFeature = new ol.Feature({
        geometry: new ol.geom.Point(mapCentre),
        name: 'Null Island',
        population: 4000,
        rainfall: 500
    });

    var iconStyle = new ol.style.Style({
        image: new ol.style.Icon(/** @type {olx.style.IconOptions} */ ({
            anchor: [0.5, 1],
            anchorXUnits: 'fraction',
            anchorYUnits: 'fraction',
            scale: icon_scale,
           // src: 'https://openlayers.org/en/v4.6.5/examples/data/icon.png'
            src: icon_source

        }))
    });
    iconFeature.setStyle(iconStyle);
    // now we add the feature to the map via a Vector source and Vector layer
    var vectorSource = new ol.source.Vector({});
    vectorSource.addFeature(iconFeature);
    var vector = new ol.layer.Vector({
        source: vectorSource
    });
    map.addLayer(vector);

    // If a user clicks on the star, then we'll show the hobosm greeting
    // The greeting will go into another HTML element, with id="greeting-container"
    // and this will be shown as an Overlay on the map
    map.addOverlay(overlay);
    //overlay.setPosition(mapCentre);
    // Finally we add the onclick listener to display the greeting when the star is clicked
    // The way this works is that the onclick listener is attached to the map,
    // and then it works out which Feature or Features have been hit
    map.on('click', function(e) {

        var position = e.coordinate;

        var lonlat = ol.proj.toLonLat(e.coordinate);
        //Then read the values from the array where 0 is the first
        var lon = lonlat[0];
        var lat = lonlat[1];
        var lonfield = document.getElementById('jform_longitude');
        lonfield.value = lon;
        var latfield = document.getElementById('jform_latitude');
        latfield.value = lat;

        var iconFeature = new ol.Feature({
            geometry: new ol.geom.Point(position)
        });
        iconFeature.setStyle(iconStyle);
        vectorSource.clear();
        vector.getSource().addFeature(iconFeature);
        //we can set animation, a smooth map repositioning
        //map.getView().animate({center: position}, {duration:1000});
        if (infobox_content) {
            container.style.width = infobox_width+"px";
            content.innerHTML = infobox_content;
            overlay.setPosition(position);
        }
        //map reposition without animation
        map.getView().setCenter(position);
    });

    //Instantiate with some options and add the Control
    var geocoder = new Geocoder('nominatim', {
        provider: 'osm',
        lang: 'en',
        placeholder: 'Search for ...',
        limit: 5,
        debug: false,
        autoComplete: true,
        keepOpen: true
    });
    map.addControl(geocoder);

//Listen when an address is chosen
    geocoder.on('addresschosen', function (evt) {
        console.info(evt['coordinate']);
        var lonlat = ol.proj.toLonLat(evt['coordinate']);
        //Then read the values from the array where 0 is the first
        var lon = lonlat[0];
        var lat = lonlat[1];
        var lonfield = document.getElementById('jform_longitude');
        lonfield.value = lon;
        var latfield = document.getElementById('jform_latitude');
        latfield.value = lat;
    });

});
