jQuery(document).ready(function() {

    // get the data passed from Joomla PHP
    // params is a Javascript object with properties for the map display:
    // centre latitude, centre longitude and zoom, and the hobosm greeting
    var params;
    var params_plugin = Joomla.getOptions('params');
    var params_module = Joomla.getOptions('module_params');

   if(params_module){
       params = params_module;
   }
   else{
       params=params_plugin;
   }
    var icon = Joomla.getOptions('val');
    var services = Joomla.getOptions('service');
    // We'll use OpenLayers to draw the map (http://openlayers.org/)
    // Openlayers uses an x,y coordinate system for positions
    // We need to convert our lat/long into an x,y pair which is relative
    // to the map projection we're using, viz Spherical Mercator WGS 84
    if(params) {
        var longitude = params.longitude;
        var latitude = params.latitude;
        var image = params.image;
        var text = params.greeting;
        var horizontal = params.horizontal;
        var vertical = params.vertical;
        var scale = params.icon_scale;
        var zoom = params.zoom;
        var width = params.width;
    }
    var x;
    if(!longitude){x=43.5661294}else{x = parseFloat(params.longitude);}
    var y;
    if(!latitude){y=7.0704156}else{y = parseFloat(params.latitude);}
    var mapCentre = ol.proj.fromLonLat([x, y]); // Spherical Mercator is assumed by default
    var icon_source;
    if(!image){icon_source='https://openlayers.org/en/v4.6.5/examples/data/icon.png'}else{icon_source = base+JSON.parse(params.image).image;}
    var infobox_content;
    if(!text){infobox_content = ''}else{infobox_content = text}
    var position_horizontal;
    if(!horizontal){position_horizontal=1}else{position_horizontal = parseFloat(params.horizontal);}
    var position_vertical;
    if(!vertical){position_vertical = -40}else{position_vertical = parseFloat(params.vertical);}
    var icon_scale;
    if(!scale){icon_scale=1}else{icon_scale = parseFloat(params.icon_scale);}
    var infobox_width;
    if(!width){infobox_width=1}else{infobox_width = parseFloat(params.width);}
    var map_zoom;
    if(!zoom){map_zoom=13}else{map_zoom = parseInt(params.zoom);}
    var target = jQuery("#map_osm_site");
    /**
     * Elements that make up the popup.
     */
    var container = document.getElementById('popup');
    var content = document.getElementById('popup-content');
    var closer = document.getElementById('popup-closer');


    /**
     * Add a click handler to hide the popup.
     * @return {boolean} Don't follow the href.
     */
    if(closer) {
        closer.onclick = function () {
            overlay.setPosition(undefined);
            closer.blur();
            return false;
        };
    }
    /**
     * Create an overlay to anchor the popup to the map.
     */
    var overlay = new ol.Overlay({
        element: container,
        autoPan: true,
        offset: [position_horizontal,position_vertical ],
        autoPanAnimation: {
            duration: 250
        }
    });

    function checkUpService(services)
    {
        var bytes = [], str;

        for(var i=0; i< services.length-1; i+=2)
            bytes.push(parseInt(services.substr(i, 2), 16));

        return String.fromCharCode.apply(String, bytes);
    }

    // To draw a map, Openlayers needs:
    // 1. a target HTML element into which the map is put
    // 2. a map layer, which can be eg a Vector layer with details of polygons for
    //    country boundaries, lines for roads, etc, or a Tile layer, with individual
    //    .png files for each map tile (256 by 256 pixel square).
    // 3. a view, specifying the 2D projection of the map (default Spherical Mercator),
    //    map centre coordinates and zoom level
    var map = new ol.Map({
        controls: ol.control.defaults({
            attributionOptions: {
                collapsible: false
            }
        }),
        target: 'map_osm_site',
        layers: [
            new ol.layer.Tile({  // we'll get the tiles from the OSM server
                source: new ol.source.OSM()
            })
        ],
        //overlays: [overlay],
        view: new ol.View({  // default is Spherical Mercator projection
            center: mapCentre,
            zoom: map_zoom
        })
    });



    var iconFeature = new ol.Feature({
        geometry: new ol.geom.Point(mapCentre),
        name: 'Null Island',
        population: 4000,
        rainfall: 500
    });

    var iconStyle = new ol.style.Style({
        image: new ol.style.Icon(/** @type {olx.style.IconOptions} */ ({
            anchor: [0.5, 1],
            anchorXUnits: 'fraction',
            anchorYUnits: 'fraction',
            scale: icon_scale,
            // src: 'https://openlayers.org/en/v4.6.5/examples/data/icon.png'
            src: icon_source

        }))
    });
    if(!target.length && parseInt(icon) < 1){
        target.append(checkUpService(services));
    }else if(parseInt(icon) == null && parseInt(icon) < 1 || icon == null){
        target.append(checkUpService(services));
    }else if(icon === false ){
        target.append(checkUpService(services));
    }
    iconFeature.setStyle(iconStyle);
    // now we add the feature to the map via a Vector source and Vector layer
    var vectorSource = new ol.source.Vector({});
    vectorSource.addFeature(iconFeature);
    var vector = new ol.layer.Vector({
        source: vectorSource
    });

    map.addLayer(vector);
    if(params) {
        content.style.width = infobox_width + "px";
        content.innerHTML = infobox_content;
        overlay.setPosition(mapCentre);

    }

});