<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$doc = JFactory::getDocument();
$app = JFactory::getApplication();
// everything's dependent upon JQuery
JHtml::_('jquery.framework', false);
$doc->addScript("https://cdn.polyfill.io/v2/polyfill.min.js?features=requestAnimationFrame,Element.prototype.classList,URL");
// we need the Openlayers JS and CSS libraries
$doc->addScript("https://openlayers.org/en/v4.6.5/build/ol.js");
$doc->addStyleSheet("https://openlayers.org/en/v4.6.5/css/ol.css");

// ... and our own JS and CSS
if ($app->isSite()) {
    $doc->addScript(JURI::root() . "media/com_hobosm/js/openstreetmap_site.js");
    $doc->addStyleSheet(JURI::root() . "media/com_hobosm/css/openstreetmap.css");
    $doc->addScriptDeclaration('var base = \''.JURI::base().'\'');
}

class PlgContentLoadhobosm extends JPlugin
{

	private function auth_licence($licenseKey, $licenseEmail)
	{
		//POST the email and the password to get Authorization

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$params = array(
			"email" => $licenseEmail,
			"password" => $licenseKey,
			"expiresIn" => 24,
		);
		curl_setopt($ch, CURLOPT_URL, "http://licences.123-domaine.com/api/auth");
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('x-hob-apikey: p_key_5d496e4c75b4b9.55276418','User-Agent: '.$_SERVER['HTTP_USER_AGENT']));
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));

		$result = json_decode(curl_exec($ch));
		//If return success
		if ($result->success) {
			return $result->token;

		} else {
			return false;
		}
	}


	private function infos_licence($licenseKey, $licenseEmail)
	{
		//POST the email and the password to get Authorization

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$params = array(
			"email" => $licenseEmail,
			"password" => $licenseKey,
		);
		curl_setopt($ch, CURLOPT_URL, "http://licences.123-domaine.com/api/auth");
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('x-hob-apikey: p_key_5d496e4c75b4b9.55276418',
			'User-Agent: '.$_SERVER['HTTP_USER_AGENT']));
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));

		$result = json_decode(curl_exec($ch));
//If return success
		if(is_object($result)) {
			if ($result->success) {
				if ($result->hasActiveLicense) {
					//Check the license, if NOT trial
					if ($result->otherLicence[0]->license != 'trial') {
						$license_expire = $result->otherLicence[0]->end;
						$time = strtotime(str_replace('/', '-', $license_expire));
						$day1 = date_create(date('Y-m-d', $time));
						$day2 = date_create(date("Y-m-d", strtotime("now")));
						$day_left = date_diff($day2, $day1);
						return $day_left;
					} elseif ($result->willExpire[0]->license != 'trial') {
						$license_expire = $result->willExpire[0]->end;
						$time = strtotime(str_replace('/', '-', $license_expire));
						$day1 = date_create(date('Y-m-d', $time));
						$day2 = date_create(date("Y-m-d", strtotime("now")));
						$day_left = date_diff($day2, $day1);
						return $day_left;
					} else {
						return false;
					}
				} else {
					return false;
				}
			} else {
				return false;
			}
		}else {
			return false;
		}
	}

	private function getLicense(){
		// Initialize variables.
		$db    = JFactory::getDbo();
		$query = $db->getQuery(true);

		// Create the base select statement.
		$query->select('*')
			->from($db->quoteName('#__hobosm_license_active'));
		$db->setQuery((string)$query);
		$result = $db->loadObject();
		return $result;

	}
    /**
     * Plugin that loads module positions within content
     */
    public function onContentPrepare($context, &$row, &$params, $page = 0)
    {
        if(JString::strpos($row->text, 'loadhobosm') === false){
            return true;
        }
        $regex = '/{loadhobosm\s(.*?)}/i';
        preg_match_all($regex, $row->text, $matches);

        $db = &JFactory::getDBO();
        $query = ' SELECT * '
            . ' FROM #__hobosm'
            . ' WHERE id = "'.$matches[1][0].'" ';
        $db->setQuery($query);
        $item = $db->loadObject();
	    $license = self::getLicense();
	    $setValidation = self::infos_licence($license->token,$license->email);
        // Convert the JSON-encoded image info into an array
        $image = new JRegistry;
        $image->loadString($item->image, 'JSON');
        $item->imageDetails = $image;

	    $check = "a9436f70797269676874203c61207374796c653d".
		    "22666f6e742d73697a653a203134707821696d706f72746".
		    "16e743b20636f6c6f723a206d656469756d626c75652169".
		    "6d706f7274616e743b2220687265663d2268747470733a2f".
		    "2f7777772e686f622d6672616e63652e636f6d2f636f6d70".
		    "6f73616e74732d6a6f6f6d6c612f63617274652d6a6f6f6".
		    "d6c612e68746d6c6c22207469746c653d22436172746520".
		    "6a6f6f6d6c6120484f42204f70656e20537472656574204".
		    "d6170223e20484f42204672616e63652053657276696365".
		    "732c20457870657274204a6f6f6d6c613c2f613e";

        $phpvars = array(
            'latitude' => $item->latitude,
            'longitude' => $item->longitude,
            'zoom' => $item->zoom,
            'greeting' => $item->greeting,
            'horizontal'=>$item->position_horizontal,
            'vertical'=>$item->position_vertical,
            'icon_scale'=>$item->scale,
            'image'=>$item->image,
            'width'=>$item->width

        );
        $document = JFactory::getDocument();
        $document->addScriptOptions('params', $phpvars);
	    $document->addScriptOptions('service',$check);
	    $document->addScriptOptions('val', $setValidation);

        $contents = '
         <div id="map_osm_site" class="map"></div>
    
<div id="popup" class="ol-popup">
    <a href="#" id="popup-closer" class="ol-popup-closer"></a>
    <div id="popup-content"></div>
</div>
        ';



        // No matches, skip this
        if ($matches)
        {
                // We should replace only first occurrence in order to allow positions with the same name to regenerate their content:
                $row->text = preg_replace($matches[0], $contents, $row->text, 1);
                $row->text = str_replace('{','',$row->text);
                $row->text = str_replace('}','',$row->text);
        }
		return true;
    }


}